/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.tencent.subscribe.avro;

import org.apache.avro.specific.SpecificData;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class Record extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -4851815814100308201L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Record\",\"namespace\":\"com.tencent.subscribe.avro\",\"fields\":[{\"name\":\"id\",\"type\":\"long\",\"doc\":\"unique id of this record in the whole stream\"},{\"name\":\"version\",\"type\":\"int\",\"doc\":\"protocol version\"},{\"name\":\"messageType\",\"type\":{\"type\":\"enum\",\"name\":\"MessageType\",\"symbols\":[\"INSERT\",\"UPDATE\",\"DELETE\",\"DDL\",\"BEGIN\",\"COMMIT\",\"HEARTBEAT\",\"CHECKPOINT\",\"ROLLBACK\"]},\"aliases\":[\"operation\"]},{\"name\":\"fileName\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"binlog file name\"},{\"name\":\"timestamp\",\"type\":\"long\",\"doc\":\"record log timestamp\",\"aliases\":[\"sourceTimestamp\"]},{\"name\":\"gtid\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"position\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"end_log_pos of last event (exclude commit) in transaction\",\"aliases\":[\"sourcePosition\"]},{\"name\":\"safePosition\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"end_log_pos of begin event in transaction\",\"default\":\"\",\"aliases\":[\"safeSourcePosition\"]},{\"name\":\"transactionId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"transaction id\",\"default\":\"\",\"aliases\":[\"sourceTxid\"]},{\"name\":\"serverId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"threadId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"sourceType\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"source database type\",\"aliases\":[\"source.sourceType\"]},{\"name\":\"sourceVersion\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"source database version\",\"aliases\":[\"source.version\"]},{\"name\":\"schemaName\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"name of source schema if exist\"},{\"name\":\"tableName\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"name of source table if exist\"},{\"name\":\"objectName\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"schemaName.tableName\",\"default\":\"\"},{\"name\":\"columns\",\"type\":[\"null\",{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"Field\",\"doc\":\"definition of column\",\"fields\":[{\"name\":\"name\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"column names for table\"},{\"name\":\"dataTypeNumber\",\"type\":\"int\"},{\"name\":\"isKey\",\"type\":\"boolean\"},{\"name\":\"originalType\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"datatype of this column in source db\"}]}}],\"default\":null,\"aliases\":[\"fields\"]},{\"name\":\"oldColumns\",\"type\":[\"null\",\"bytes\",{\"type\":\"array\",\"items\":[\"null\",{\"type\":\"record\",\"name\":\"Integer\",\"doc\":\"defined Integer type in source db\",\"fields\":[{\"name\":\"precision\",\"type\":\"int\",\"doc\":\"byte length of int\"},{\"name\":\"value\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}}]},{\"type\":\"record\",\"name\":\"Character\",\"fields\":[{\"name\":\"charset\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"value\",\"type\":\"bytes\"}]},{\"type\":\"record\",\"name\":\"Decimal\",\"doc\":\"defined decimal (or double) type in source db\",\"fields\":[{\"name\":\"value\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"precision\",\"type\":\"int\",\"doc\":\"how many digits stored in total\"},{\"name\":\"scale\",\"type\":\"int\",\"doc\":\"how many digits after decimal point\"}]},{\"type\":\"record\",\"name\":\"Float\",\"doc\":\"defined Float type in source db\",\"fields\":[{\"name\":\"value\",\"type\":\"double\"},{\"name\":\"precision\",\"type\":\"int\",\"doc\":\"how many digits stored in total\"},{\"name\":\"scale\",\"type\":\"int\",\"doc\":\"how many digits after decimal point\"}]},{\"type\":\"record\",\"name\":\"Timestamp\",\"fields\":[{\"name\":\"timestamp\",\"type\":\"long\"},{\"name\":\"millis\",\"type\":\"int\"}]},{\"type\":\"record\",\"name\":\"DateTime\",\"fields\":[{\"name\":\"year\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"month\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"day\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"hour\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"minute\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"second\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"millis\",\"type\":[\"null\",\"int\"],\"default\":null}]},{\"type\":\"record\",\"name\":\"TimestampWithTimeZone\",\"fields\":[{\"name\":\"value\",\"type\":\"DateTime\"},{\"name\":\"timezone\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}}]},{\"type\":\"record\",\"name\":\"BinaryGeometry\",\"fields\":[{\"name\":\"type\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"value\",\"type\":\"bytes\"}]},{\"type\":\"record\",\"name\":\"TextGeometry\",\"fields\":[{\"name\":\"type\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"value\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}}]},{\"type\":\"record\",\"name\":\"BinaryObject\",\"fields\":[{\"name\":\"type\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"value\",\"type\":\"bytes\"}]},{\"type\":\"record\",\"name\":\"TextObject\",\"fields\":[{\"name\":\"type\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"value\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}}]},{\"type\":\"enum\",\"name\":\"EmptyObject\",\"symbols\":[\"NULL\",\"NONE\"]}]}],\"doc\":\"values of a row before modify. if values' size is over 20M, they will be discarded\",\"default\":null,\"aliases\":[\"beforeImages\"]},{\"name\":\"newColumns\",\"type\":[\"null\",\"bytes\",{\"type\":\"array\",\"items\":[\"null\",\"Integer\",\"Character\",\"Decimal\",\"Float\",\"Timestamp\",\"DateTime\",\"TimestampWithTimeZone\",\"BinaryGeometry\",\"TextGeometry\",\"BinaryObject\",\"TextObject\",\"EmptyObject\"]}],\"doc\":\"values of a row after modify. if values' size is over 20M, they will be discarded\",\"default\":null,\"aliases\":[\"afterImages\"]},{\"name\":\"sql\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"doc\":\"ddl sql if this is a ddl event\"},{\"name\":\"executionTime\",\"type\":\"int\",\"doc\":\"execution time of ddl sql\"},{\"name\":\"heartbeatTimestamp\",\"type\":\"long\",\"doc\":\"timestamp of heartbeat send by master if this is a heartbeat record\"},{\"name\":\"syncedGtid\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"fakeGtid\",\"type\":\"boolean\",\"doc\":\"for some database that has no gtid, a fake gtid will be assigned\"},{\"name\":\"pkNames\",\"type\":{\"type\":\"array\",\"items\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},\"doc\":\"primary keys\"},{\"name\":\"readerTimestamp\",\"type\":\"long\",\"doc\":\"a millisecond timestamp. Not implemented at current version\",\"aliases\":[\"readerThroughoutTime\"]},{\"name\":\"tags\",\"type\":{\"type\":\"map\",\"values\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"avro.java.string\":\"String\"},\"doc\":\"tags to identify properties of this record\",\"default\":{}},{\"name\":\"index\",\"type\":\"int\",\"doc\":\"Not implemented at current version\",\"default\":-1},{\"name\":\"total\",\"type\":\"int\",\"doc\":\"Not implemented at current version\",\"default\":-1}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<Record> ENCODER =
      new BinaryMessageEncoder<Record>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Record> DECODER =
      new BinaryMessageDecoder<Record>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   */
  public static BinaryMessageDecoder<Record> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   */
  public static BinaryMessageDecoder<Record> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<Record>(MODEL$, SCHEMA$, resolver);
  }

  /** Serializes this Record to a ByteBuffer. */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /** Deserializes a Record from a ByteBuffer. */
  public static Record fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  /** unique id of this record in the whole stream */
  @Deprecated public long id;
  /** protocol version */
  @Deprecated public int version;
  @Deprecated public com.tencent.subscribe.avro.MessageType messageType;
  /** binlog file name */
  @Deprecated public java.lang.String fileName;
  /** record log timestamp */
  @Deprecated public long timestamp;
  @Deprecated public java.lang.String gtid;
  /** end_log_pos of last event (exclude commit) in transaction */
  @Deprecated public java.lang.String position;
  /** end_log_pos of begin event in transaction */
  @Deprecated public java.lang.String safePosition;
  /** transaction id */
  @Deprecated public java.lang.String transactionId;
  @Deprecated public java.lang.String serverId;
  @Deprecated public java.lang.String threadId;
  /** source database type */
  @Deprecated public java.lang.String sourceType;
  /** source database version */
  @Deprecated public java.lang.String sourceVersion;
  /** name of source schema if exist */
  @Deprecated public java.lang.String schemaName;
  /** name of source table if exist */
  @Deprecated public java.lang.String tableName;
  /** schemaName.tableName */
  @Deprecated public java.lang.String objectName;
  @Deprecated public java.util.List<com.tencent.subscribe.avro.Field> columns;
  /** values of a row before modify. if values' size is over 20M, they will be discarded */
  @Deprecated public java.lang.Object oldColumns;
  /** values of a row after modify. if values' size is over 20M, they will be discarded */
  @Deprecated public java.lang.Object newColumns;
  /** ddl sql if this is a ddl event */
  @Deprecated public java.lang.String sql;
  /** execution time of ddl sql */
  @Deprecated public int executionTime;
  /** timestamp of heartbeat send by master if this is a heartbeat record */
  @Deprecated public long heartbeatTimestamp;
  @Deprecated public java.lang.String syncedGtid;
  /** for some database that has no gtid, a fake gtid will be assigned */
  @Deprecated public boolean fakeGtid;
  /** primary keys */
  @Deprecated public java.util.List<java.lang.String> pkNames;
  /** a millisecond timestamp. Not implemented at current version */
  @Deprecated public long readerTimestamp;
  /** tags to identify properties of this record */
  @Deprecated public java.util.Map<java.lang.String,java.lang.String> tags;
  /** Not implemented at current version */
  @Deprecated public int index;
  /** Not implemented at current version */
  @Deprecated public int total;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Record() {}

  /**
   * All-args constructor.
   * @param id unique id of this record in the whole stream
   * @param version protocol version
   * @param messageType The new value for messageType
   * @param fileName binlog file name
   * @param timestamp record log timestamp
   * @param gtid The new value for gtid
   * @param position end_log_pos of last event (exclude commit) in transaction
   * @param safePosition end_log_pos of begin event in transaction
   * @param transactionId transaction id
   * @param serverId The new value for serverId
   * @param threadId The new value for threadId
   * @param sourceType source database type
   * @param sourceVersion source database version
   * @param schemaName name of source schema if exist
   * @param tableName name of source table if exist
   * @param objectName schemaName.tableName
   * @param columns The new value for columns
   * @param oldColumns values of a row before modify. if values' size is over 20M, they will be discarded
   * @param newColumns values of a row after modify. if values' size is over 20M, they will be discarded
   * @param sql ddl sql if this is a ddl event
   * @param executionTime execution time of ddl sql
   * @param heartbeatTimestamp timestamp of heartbeat send by master if this is a heartbeat record
   * @param syncedGtid The new value for syncedGtid
   * @param fakeGtid for some database that has no gtid, a fake gtid will be assigned
   * @param pkNames primary keys
   * @param readerTimestamp a millisecond timestamp. Not implemented at current version
   * @param tags tags to identify properties of this record
   * @param index Not implemented at current version
   * @param total Not implemented at current version
   */
  public Record(java.lang.Long id, java.lang.Integer version, com.tencent.subscribe.avro.MessageType messageType, java.lang.String fileName, java.lang.Long timestamp, java.lang.String gtid, java.lang.String position, java.lang.String safePosition, java.lang.String transactionId, java.lang.String serverId, java.lang.String threadId, java.lang.String sourceType, java.lang.String sourceVersion, java.lang.String schemaName, java.lang.String tableName, java.lang.String objectName, java.util.List<com.tencent.subscribe.avro.Field> columns, java.lang.Object oldColumns, java.lang.Object newColumns, java.lang.String sql, java.lang.Integer executionTime, java.lang.Long heartbeatTimestamp, java.lang.String syncedGtid, java.lang.Boolean fakeGtid, java.util.List<java.lang.String> pkNames, java.lang.Long readerTimestamp, java.util.Map<java.lang.String,java.lang.String> tags, java.lang.Integer index, java.lang.Integer total) {
    this.id = id;
    this.version = version;
    this.messageType = messageType;
    this.fileName = fileName;
    this.timestamp = timestamp;
    this.gtid = gtid;
    this.position = position;
    this.safePosition = safePosition;
    this.transactionId = transactionId;
    this.serverId = serverId;
    this.threadId = threadId;
    this.sourceType = sourceType;
    this.sourceVersion = sourceVersion;
    this.schemaName = schemaName;
    this.tableName = tableName;
    this.objectName = objectName;
    this.columns = columns;
    this.oldColumns = oldColumns;
    this.newColumns = newColumns;
    this.sql = sql;
    this.executionTime = executionTime;
    this.heartbeatTimestamp = heartbeatTimestamp;
    this.syncedGtid = syncedGtid;
    this.fakeGtid = fakeGtid;
    this.pkNames = pkNames;
    this.readerTimestamp = readerTimestamp;
    this.tags = tags;
    this.index = index;
    this.total = total;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return version;
    case 2: return messageType;
    case 3: return fileName;
    case 4: return timestamp;
    case 5: return gtid;
    case 6: return position;
    case 7: return safePosition;
    case 8: return transactionId;
    case 9: return serverId;
    case 10: return threadId;
    case 11: return sourceType;
    case 12: return sourceVersion;
    case 13: return schemaName;
    case 14: return tableName;
    case 15: return objectName;
    case 16: return columns;
    case 17: return oldColumns;
    case 18: return newColumns;
    case 19: return sql;
    case 20: return executionTime;
    case 21: return heartbeatTimestamp;
    case 22: return syncedGtid;
    case 23: return fakeGtid;
    case 24: return pkNames;
    case 25: return readerTimestamp;
    case 26: return tags;
    case 27: return index;
    case 28: return total;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.Long)value$; break;
    case 1: version = (java.lang.Integer)value$; break;
    case 2: messageType = (com.tencent.subscribe.avro.MessageType)value$; break;
    case 3: fileName = (java.lang.String)value$; break;
    case 4: timestamp = (java.lang.Long)value$; break;
    case 5: gtid = (java.lang.String)value$; break;
    case 6: position = (java.lang.String)value$; break;
    case 7: safePosition = (java.lang.String)value$; break;
    case 8: transactionId = (java.lang.String)value$; break;
    case 9: serverId = (java.lang.String)value$; break;
    case 10: threadId = (java.lang.String)value$; break;
    case 11: sourceType = (java.lang.String)value$; break;
    case 12: sourceVersion = (java.lang.String)value$; break;
    case 13: schemaName = (java.lang.String)value$; break;
    case 14: tableName = (java.lang.String)value$; break;
    case 15: objectName = (java.lang.String)value$; break;
    case 16: columns = (java.util.List<com.tencent.subscribe.avro.Field>)value$; break;
    case 17: oldColumns = (java.lang.Object)value$; break;
    case 18: newColumns = (java.lang.Object)value$; break;
    case 19: sql = (java.lang.String)value$; break;
    case 20: executionTime = (java.lang.Integer)value$; break;
    case 21: heartbeatTimestamp = (java.lang.Long)value$; break;
    case 22: syncedGtid = (java.lang.String)value$; break;
    case 23: fakeGtid = (java.lang.Boolean)value$; break;
    case 24: pkNames = (java.util.List<java.lang.String>)value$; break;
    case 25: readerTimestamp = (java.lang.Long)value$; break;
    case 26: tags = (java.util.Map<java.lang.String,java.lang.String>)value$; break;
    case 27: index = (java.lang.Integer)value$; break;
    case 28: total = (java.lang.Integer)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return unique id of this record in the whole stream
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * Sets the value of the 'id' field.
   * unique id of this record in the whole stream
   * @param value the value to set.
   */
  public void setId(java.lang.Long value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'version' field.
   * @return protocol version
   */
  public java.lang.Integer getVersion() {
    return version;
  }

  /**
   * Sets the value of the 'version' field.
   * protocol version
   * @param value the value to set.
   */
  public void setVersion(java.lang.Integer value) {
    this.version = value;
  }

  /**
   * Gets the value of the 'messageType' field.
   * @return The value of the 'messageType' field.
   */
  public com.tencent.subscribe.avro.MessageType getMessageType() {
    return messageType;
  }

  /**
   * Sets the value of the 'messageType' field.
   * @param value the value to set.
   */
  public void setMessageType(com.tencent.subscribe.avro.MessageType value) {
    this.messageType = value;
  }

  /**
   * Gets the value of the 'fileName' field.
   * @return binlog file name
   */
  public java.lang.String getFileName() {
    return fileName;
  }

  /**
   * Sets the value of the 'fileName' field.
   * binlog file name
   * @param value the value to set.
   */
  public void setFileName(java.lang.String value) {
    this.fileName = value;
  }

  /**
   * Gets the value of the 'timestamp' field.
   * @return record log timestamp
   */
  public java.lang.Long getTimestamp() {
    return timestamp;
  }

  /**
   * Sets the value of the 'timestamp' field.
   * record log timestamp
   * @param value the value to set.
   */
  public void setTimestamp(java.lang.Long value) {
    this.timestamp = value;
  }

  /**
   * Gets the value of the 'gtid' field.
   * @return The value of the 'gtid' field.
   */
  public java.lang.String getGtid() {
    return gtid;
  }

  /**
   * Sets the value of the 'gtid' field.
   * @param value the value to set.
   */
  public void setGtid(java.lang.String value) {
    this.gtid = value;
  }

  /**
   * Gets the value of the 'position' field.
   * @return end_log_pos of last event (exclude commit) in transaction
   */
  public java.lang.String getPosition() {
    return position;
  }

  /**
   * Sets the value of the 'position' field.
   * end_log_pos of last event (exclude commit) in transaction
   * @param value the value to set.
   */
  public void setPosition(java.lang.String value) {
    this.position = value;
  }

  /**
   * Gets the value of the 'safePosition' field.
   * @return end_log_pos of begin event in transaction
   */
  public java.lang.String getSafePosition() {
    return safePosition;
  }

  /**
   * Sets the value of the 'safePosition' field.
   * end_log_pos of begin event in transaction
   * @param value the value to set.
   */
  public void setSafePosition(java.lang.String value) {
    this.safePosition = value;
  }

  /**
   * Gets the value of the 'transactionId' field.
   * @return transaction id
   */
  public java.lang.String getTransactionId() {
    return transactionId;
  }

  /**
   * Sets the value of the 'transactionId' field.
   * transaction id
   * @param value the value to set.
   */
  public void setTransactionId(java.lang.String value) {
    this.transactionId = value;
  }

  /**
   * Gets the value of the 'serverId' field.
   * @return The value of the 'serverId' field.
   */
  public java.lang.String getServerId() {
    return serverId;
  }

  /**
   * Sets the value of the 'serverId' field.
   * @param value the value to set.
   */
  public void setServerId(java.lang.String value) {
    this.serverId = value;
  }

  /**
   * Gets the value of the 'threadId' field.
   * @return The value of the 'threadId' field.
   */
  public java.lang.String getThreadId() {
    return threadId;
  }

  /**
   * Sets the value of the 'threadId' field.
   * @param value the value to set.
   */
  public void setThreadId(java.lang.String value) {
    this.threadId = value;
  }

  /**
   * Gets the value of the 'sourceType' field.
   * @return source database type
   */
  public java.lang.String getSourceType() {
    return sourceType;
  }

  /**
   * Sets the value of the 'sourceType' field.
   * source database type
   * @param value the value to set.
   */
  public void setSourceType(java.lang.String value) {
    this.sourceType = value;
  }

  /**
   * Gets the value of the 'sourceVersion' field.
   * @return source database version
   */
  public java.lang.String getSourceVersion() {
    return sourceVersion;
  }

  /**
   * Sets the value of the 'sourceVersion' field.
   * source database version
   * @param value the value to set.
   */
  public void setSourceVersion(java.lang.String value) {
    this.sourceVersion = value;
  }

  /**
   * Gets the value of the 'schemaName' field.
   * @return name of source schema if exist
   */
  public java.lang.String getSchemaName() {
    return schemaName;
  }

  /**
   * Sets the value of the 'schemaName' field.
   * name of source schema if exist
   * @param value the value to set.
   */
  public void setSchemaName(java.lang.String value) {
    this.schemaName = value;
  }

  /**
   * Gets the value of the 'tableName' field.
   * @return name of source table if exist
   */
  public java.lang.String getTableName() {
    return tableName;
  }

  /**
   * Sets the value of the 'tableName' field.
   * name of source table if exist
   * @param value the value to set.
   */
  public void setTableName(java.lang.String value) {
    this.tableName = value;
  }

  /**
   * Gets the value of the 'objectName' field.
   * @return schemaName.tableName
   */
  public java.lang.String getObjectName() {
    return objectName;
  }

  /**
   * Sets the value of the 'objectName' field.
   * schemaName.tableName
   * @param value the value to set.
   */
  public void setObjectName(java.lang.String value) {
    this.objectName = value;
  }

  /**
   * Gets the value of the 'columns' field.
   * @return The value of the 'columns' field.
   */
  public java.util.List<com.tencent.subscribe.avro.Field> getColumns() {
    return columns;
  }

  /**
   * Sets the value of the 'columns' field.
   * @param value the value to set.
   */
  public void setColumns(java.util.List<com.tencent.subscribe.avro.Field> value) {
    this.columns = value;
  }

  /**
   * Gets the value of the 'oldColumns' field.
   * @return values of a row before modify. if values' size is over 20M, they will be discarded
   */
  public java.lang.Object getOldColumns() {
    return oldColumns;
  }

  /**
   * Sets the value of the 'oldColumns' field.
   * values of a row before modify. if values' size is over 20M, they will be discarded
   * @param value the value to set.
   */
  public void setOldColumns(java.lang.Object value) {
    this.oldColumns = value;
  }

  /**
   * Gets the value of the 'newColumns' field.
   * @return values of a row after modify. if values' size is over 20M, they will be discarded
   */
  public java.lang.Object getNewColumns() {
    return newColumns;
  }

  /**
   * Sets the value of the 'newColumns' field.
   * values of a row after modify. if values' size is over 20M, they will be discarded
   * @param value the value to set.
   */
  public void setNewColumns(java.lang.Object value) {
    this.newColumns = value;
  }

  /**
   * Gets the value of the 'sql' field.
   * @return ddl sql if this is a ddl event
   */
  public java.lang.String getSql() {
    return sql;
  }

  /**
   * Sets the value of the 'sql' field.
   * ddl sql if this is a ddl event
   * @param value the value to set.
   */
  public void setSql(java.lang.String value) {
    this.sql = value;
  }

  /**
   * Gets the value of the 'executionTime' field.
   * @return execution time of ddl sql
   */
  public java.lang.Integer getExecutionTime() {
    return executionTime;
  }

  /**
   * Sets the value of the 'executionTime' field.
   * execution time of ddl sql
   * @param value the value to set.
   */
  public void setExecutionTime(java.lang.Integer value) {
    this.executionTime = value;
  }

  /**
   * Gets the value of the 'heartbeatTimestamp' field.
   * @return timestamp of heartbeat send by master if this is a heartbeat record
   */
  public java.lang.Long getHeartbeatTimestamp() {
    return heartbeatTimestamp;
  }

  /**
   * Sets the value of the 'heartbeatTimestamp' field.
   * timestamp of heartbeat send by master if this is a heartbeat record
   * @param value the value to set.
   */
  public void setHeartbeatTimestamp(java.lang.Long value) {
    this.heartbeatTimestamp = value;
  }

  /**
   * Gets the value of the 'syncedGtid' field.
   * @return The value of the 'syncedGtid' field.
   */
  public java.lang.String getSyncedGtid() {
    return syncedGtid;
  }

  /**
   * Sets the value of the 'syncedGtid' field.
   * @param value the value to set.
   */
  public void setSyncedGtid(java.lang.String value) {
    this.syncedGtid = value;
  }

  /**
   * Gets the value of the 'fakeGtid' field.
   * @return for some database that has no gtid, a fake gtid will be assigned
   */
  public java.lang.Boolean getFakeGtid() {
    return fakeGtid;
  }

  /**
   * Sets the value of the 'fakeGtid' field.
   * for some database that has no gtid, a fake gtid will be assigned
   * @param value the value to set.
   */
  public void setFakeGtid(java.lang.Boolean value) {
    this.fakeGtid = value;
  }

  /**
   * Gets the value of the 'pkNames' field.
   * @return primary keys
   */
  public java.util.List<java.lang.String> getPkNames() {
    return pkNames;
  }

  /**
   * Sets the value of the 'pkNames' field.
   * primary keys
   * @param value the value to set.
   */
  public void setPkNames(java.util.List<java.lang.String> value) {
    this.pkNames = value;
  }

  /**
   * Gets the value of the 'readerTimestamp' field.
   * @return a millisecond timestamp. Not implemented at current version
   */
  public java.lang.Long getReaderTimestamp() {
    return readerTimestamp;
  }

  /**
   * Sets the value of the 'readerTimestamp' field.
   * a millisecond timestamp. Not implemented at current version
   * @param value the value to set.
   */
  public void setReaderTimestamp(java.lang.Long value) {
    this.readerTimestamp = value;
  }

  /**
   * Gets the value of the 'tags' field.
   * @return tags to identify properties of this record
   */
  public java.util.Map<java.lang.String,java.lang.String> getTags() {
    return tags;
  }

  /**
   * Sets the value of the 'tags' field.
   * tags to identify properties of this record
   * @param value the value to set.
   */
  public void setTags(java.util.Map<java.lang.String,java.lang.String> value) {
    this.tags = value;
  }

  /**
   * Gets the value of the 'index' field.
   * @return Not implemented at current version
   */
  public java.lang.Integer getIndex() {
    return index;
  }

  /**
   * Sets the value of the 'index' field.
   * Not implemented at current version
   * @param value the value to set.
   */
  public void setIndex(java.lang.Integer value) {
    this.index = value;
  }

  /**
   * Gets the value of the 'total' field.
   * @return Not implemented at current version
   */
  public java.lang.Integer getTotal() {
    return total;
  }

  /**
   * Sets the value of the 'total' field.
   * Not implemented at current version
   * @param value the value to set.
   */
  public void setTotal(java.lang.Integer value) {
    this.total = value;
  }

  /**
   * Creates a new Record RecordBuilder.
   * @return A new Record RecordBuilder
   */
  public static com.tencent.subscribe.avro.Record.Builder newBuilder() {
    return new com.tencent.subscribe.avro.Record.Builder();
  }

  /**
   * Creates a new Record RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Record RecordBuilder
   */
  public static com.tencent.subscribe.avro.Record.Builder newBuilder(com.tencent.subscribe.avro.Record.Builder other) {
    return new com.tencent.subscribe.avro.Record.Builder(other);
  }

  /**
   * Creates a new Record RecordBuilder by copying an existing Record instance.
   * @param other The existing instance to copy.
   * @return A new Record RecordBuilder
   */
  public static com.tencent.subscribe.avro.Record.Builder newBuilder(com.tencent.subscribe.avro.Record other) {
    return new com.tencent.subscribe.avro.Record.Builder(other);
  }

  /**
   * RecordBuilder for Record instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Record>
    implements org.apache.avro.data.RecordBuilder<Record> {

    /** unique id of this record in the whole stream */
    private long id;
    /** protocol version */
    private int version;
    private com.tencent.subscribe.avro.MessageType messageType;
    /** binlog file name */
    private java.lang.String fileName;
    /** record log timestamp */
    private long timestamp;
    private java.lang.String gtid;
    /** end_log_pos of last event (exclude commit) in transaction */
    private java.lang.String position;
    /** end_log_pos of begin event in transaction */
    private java.lang.String safePosition;
    /** transaction id */
    private java.lang.String transactionId;
    private java.lang.String serverId;
    private java.lang.String threadId;
    /** source database type */
    private java.lang.String sourceType;
    /** source database version */
    private java.lang.String sourceVersion;
    /** name of source schema if exist */
    private java.lang.String schemaName;
    /** name of source table if exist */
    private java.lang.String tableName;
    /** schemaName.tableName */
    private java.lang.String objectName;
    private java.util.List<com.tencent.subscribe.avro.Field> columns;
    /** values of a row before modify. if values' size is over 20M, they will be discarded */
    private java.lang.Object oldColumns;
    /** values of a row after modify. if values' size is over 20M, they will be discarded */
    private java.lang.Object newColumns;
    /** ddl sql if this is a ddl event */
    private java.lang.String sql;
    /** execution time of ddl sql */
    private int executionTime;
    /** timestamp of heartbeat send by master if this is a heartbeat record */
    private long heartbeatTimestamp;
    private java.lang.String syncedGtid;
    /** for some database that has no gtid, a fake gtid will be assigned */
    private boolean fakeGtid;
    /** primary keys */
    private java.util.List<java.lang.String> pkNames;
    /** a millisecond timestamp. Not implemented at current version */
    private long readerTimestamp;
    /** tags to identify properties of this record */
    private java.util.Map<java.lang.String,java.lang.String> tags;
    /** Not implemented at current version */
    private int index;
    /** Not implemented at current version */
    private int total;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.tencent.subscribe.avro.Record.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.version)) {
        this.version = data().deepCopy(fields()[1].schema(), other.version);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.messageType)) {
        this.messageType = data().deepCopy(fields()[2].schema(), other.messageType);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.fileName)) {
        this.fileName = data().deepCopy(fields()[3].schema(), other.fileName);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[4].schema(), other.timestamp);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.gtid)) {
        this.gtid = data().deepCopy(fields()[5].schema(), other.gtid);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.position)) {
        this.position = data().deepCopy(fields()[6].schema(), other.position);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.safePosition)) {
        this.safePosition = data().deepCopy(fields()[7].schema(), other.safePosition);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.transactionId)) {
        this.transactionId = data().deepCopy(fields()[8].schema(), other.transactionId);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.serverId)) {
        this.serverId = data().deepCopy(fields()[9].schema(), other.serverId);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.threadId)) {
        this.threadId = data().deepCopy(fields()[10].schema(), other.threadId);
        fieldSetFlags()[10] = true;
      }
      if (isValidValue(fields()[11], other.sourceType)) {
        this.sourceType = data().deepCopy(fields()[11].schema(), other.sourceType);
        fieldSetFlags()[11] = true;
      }
      if (isValidValue(fields()[12], other.sourceVersion)) {
        this.sourceVersion = data().deepCopy(fields()[12].schema(), other.sourceVersion);
        fieldSetFlags()[12] = true;
      }
      if (isValidValue(fields()[13], other.schemaName)) {
        this.schemaName = data().deepCopy(fields()[13].schema(), other.schemaName);
        fieldSetFlags()[13] = true;
      }
      if (isValidValue(fields()[14], other.tableName)) {
        this.tableName = data().deepCopy(fields()[14].schema(), other.tableName);
        fieldSetFlags()[14] = true;
      }
      if (isValidValue(fields()[15], other.objectName)) {
        this.objectName = data().deepCopy(fields()[15].schema(), other.objectName);
        fieldSetFlags()[15] = true;
      }
      if (isValidValue(fields()[16], other.columns)) {
        this.columns = data().deepCopy(fields()[16].schema(), other.columns);
        fieldSetFlags()[16] = true;
      }
      if (isValidValue(fields()[17], other.oldColumns)) {
        this.oldColumns = data().deepCopy(fields()[17].schema(), other.oldColumns);
        fieldSetFlags()[17] = true;
      }
      if (isValidValue(fields()[18], other.newColumns)) {
        this.newColumns = data().deepCopy(fields()[18].schema(), other.newColumns);
        fieldSetFlags()[18] = true;
      }
      if (isValidValue(fields()[19], other.sql)) {
        this.sql = data().deepCopy(fields()[19].schema(), other.sql);
        fieldSetFlags()[19] = true;
      }
      if (isValidValue(fields()[20], other.executionTime)) {
        this.executionTime = data().deepCopy(fields()[20].schema(), other.executionTime);
        fieldSetFlags()[20] = true;
      }
      if (isValidValue(fields()[21], other.heartbeatTimestamp)) {
        this.heartbeatTimestamp = data().deepCopy(fields()[21].schema(), other.heartbeatTimestamp);
        fieldSetFlags()[21] = true;
      }
      if (isValidValue(fields()[22], other.syncedGtid)) {
        this.syncedGtid = data().deepCopy(fields()[22].schema(), other.syncedGtid);
        fieldSetFlags()[22] = true;
      }
      if (isValidValue(fields()[23], other.fakeGtid)) {
        this.fakeGtid = data().deepCopy(fields()[23].schema(), other.fakeGtid);
        fieldSetFlags()[23] = true;
      }
      if (isValidValue(fields()[24], other.pkNames)) {
        this.pkNames = data().deepCopy(fields()[24].schema(), other.pkNames);
        fieldSetFlags()[24] = true;
      }
      if (isValidValue(fields()[25], other.readerTimestamp)) {
        this.readerTimestamp = data().deepCopy(fields()[25].schema(), other.readerTimestamp);
        fieldSetFlags()[25] = true;
      }
      if (isValidValue(fields()[26], other.tags)) {
        this.tags = data().deepCopy(fields()[26].schema(), other.tags);
        fieldSetFlags()[26] = true;
      }
      if (isValidValue(fields()[27], other.index)) {
        this.index = data().deepCopy(fields()[27].schema(), other.index);
        fieldSetFlags()[27] = true;
      }
      if (isValidValue(fields()[28], other.total)) {
        this.total = data().deepCopy(fields()[28].schema(), other.total);
        fieldSetFlags()[28] = true;
      }
    }

    /**
     * Creates a Builder by copying an existing Record instance
     * @param other The existing instance to copy.
     */
    private Builder(com.tencent.subscribe.avro.Record other) {
            super(SCHEMA$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.version)) {
        this.version = data().deepCopy(fields()[1].schema(), other.version);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.messageType)) {
        this.messageType = data().deepCopy(fields()[2].schema(), other.messageType);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.fileName)) {
        this.fileName = data().deepCopy(fields()[3].schema(), other.fileName);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[4].schema(), other.timestamp);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.gtid)) {
        this.gtid = data().deepCopy(fields()[5].schema(), other.gtid);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.position)) {
        this.position = data().deepCopy(fields()[6].schema(), other.position);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.safePosition)) {
        this.safePosition = data().deepCopy(fields()[7].schema(), other.safePosition);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.transactionId)) {
        this.transactionId = data().deepCopy(fields()[8].schema(), other.transactionId);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.serverId)) {
        this.serverId = data().deepCopy(fields()[9].schema(), other.serverId);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.threadId)) {
        this.threadId = data().deepCopy(fields()[10].schema(), other.threadId);
        fieldSetFlags()[10] = true;
      }
      if (isValidValue(fields()[11], other.sourceType)) {
        this.sourceType = data().deepCopy(fields()[11].schema(), other.sourceType);
        fieldSetFlags()[11] = true;
      }
      if (isValidValue(fields()[12], other.sourceVersion)) {
        this.sourceVersion = data().deepCopy(fields()[12].schema(), other.sourceVersion);
        fieldSetFlags()[12] = true;
      }
      if (isValidValue(fields()[13], other.schemaName)) {
        this.schemaName = data().deepCopy(fields()[13].schema(), other.schemaName);
        fieldSetFlags()[13] = true;
      }
      if (isValidValue(fields()[14], other.tableName)) {
        this.tableName = data().deepCopy(fields()[14].schema(), other.tableName);
        fieldSetFlags()[14] = true;
      }
      if (isValidValue(fields()[15], other.objectName)) {
        this.objectName = data().deepCopy(fields()[15].schema(), other.objectName);
        fieldSetFlags()[15] = true;
      }
      if (isValidValue(fields()[16], other.columns)) {
        this.columns = data().deepCopy(fields()[16].schema(), other.columns);
        fieldSetFlags()[16] = true;
      }
      if (isValidValue(fields()[17], other.oldColumns)) {
        this.oldColumns = data().deepCopy(fields()[17].schema(), other.oldColumns);
        fieldSetFlags()[17] = true;
      }
      if (isValidValue(fields()[18], other.newColumns)) {
        this.newColumns = data().deepCopy(fields()[18].schema(), other.newColumns);
        fieldSetFlags()[18] = true;
      }
      if (isValidValue(fields()[19], other.sql)) {
        this.sql = data().deepCopy(fields()[19].schema(), other.sql);
        fieldSetFlags()[19] = true;
      }
      if (isValidValue(fields()[20], other.executionTime)) {
        this.executionTime = data().deepCopy(fields()[20].schema(), other.executionTime);
        fieldSetFlags()[20] = true;
      }
      if (isValidValue(fields()[21], other.heartbeatTimestamp)) {
        this.heartbeatTimestamp = data().deepCopy(fields()[21].schema(), other.heartbeatTimestamp);
        fieldSetFlags()[21] = true;
      }
      if (isValidValue(fields()[22], other.syncedGtid)) {
        this.syncedGtid = data().deepCopy(fields()[22].schema(), other.syncedGtid);
        fieldSetFlags()[22] = true;
      }
      if (isValidValue(fields()[23], other.fakeGtid)) {
        this.fakeGtid = data().deepCopy(fields()[23].schema(), other.fakeGtid);
        fieldSetFlags()[23] = true;
      }
      if (isValidValue(fields()[24], other.pkNames)) {
        this.pkNames = data().deepCopy(fields()[24].schema(), other.pkNames);
        fieldSetFlags()[24] = true;
      }
      if (isValidValue(fields()[25], other.readerTimestamp)) {
        this.readerTimestamp = data().deepCopy(fields()[25].schema(), other.readerTimestamp);
        fieldSetFlags()[25] = true;
      }
      if (isValidValue(fields()[26], other.tags)) {
        this.tags = data().deepCopy(fields()[26].schema(), other.tags);
        fieldSetFlags()[26] = true;
      }
      if (isValidValue(fields()[27], other.index)) {
        this.index = data().deepCopy(fields()[27].schema(), other.index);
        fieldSetFlags()[27] = true;
      }
      if (isValidValue(fields()[28], other.total)) {
        this.total = data().deepCopy(fields()[28].schema(), other.total);
        fieldSetFlags()[28] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * unique id of this record in the whole stream
      * @return The value.
      */
    public java.lang.Long getId() {
      return id;
    }

    /**
      * Sets the value of the 'id' field.
      * unique id of this record in the whole stream
      * @param value The value of 'id'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setId(long value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * unique id of this record in the whole stream
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * unique id of this record in the whole stream
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearId() {
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'version' field.
      * protocol version
      * @return The value.
      */
    public java.lang.Integer getVersion() {
      return version;
    }

    /**
      * Sets the value of the 'version' field.
      * protocol version
      * @param value The value of 'version'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setVersion(int value) {
      validate(fields()[1], value);
      this.version = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'version' field has been set.
      * protocol version
      * @return True if the 'version' field has been set, false otherwise.
      */
    public boolean hasVersion() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'version' field.
      * protocol version
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearVersion() {
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'messageType' field.
      * @return The value.
      */
    public com.tencent.subscribe.avro.MessageType getMessageType() {
      return messageType;
    }

    /**
      * Sets the value of the 'messageType' field.
      * @param value The value of 'messageType'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setMessageType(com.tencent.subscribe.avro.MessageType value) {
      validate(fields()[2], value);
      this.messageType = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'messageType' field has been set.
      * @return True if the 'messageType' field has been set, false otherwise.
      */
    public boolean hasMessageType() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'messageType' field.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearMessageType() {
      messageType = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'fileName' field.
      * binlog file name
      * @return The value.
      */
    public java.lang.String getFileName() {
      return fileName;
    }

    /**
      * Sets the value of the 'fileName' field.
      * binlog file name
      * @param value The value of 'fileName'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setFileName(java.lang.String value) {
      validate(fields()[3], value);
      this.fileName = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'fileName' field has been set.
      * binlog file name
      * @return True if the 'fileName' field has been set, false otherwise.
      */
    public boolean hasFileName() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'fileName' field.
      * binlog file name
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearFileName() {
      fileName = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'timestamp' field.
      * record log timestamp
      * @return The value.
      */
    public java.lang.Long getTimestamp() {
      return timestamp;
    }

    /**
      * Sets the value of the 'timestamp' field.
      * record log timestamp
      * @param value The value of 'timestamp'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setTimestamp(long value) {
      validate(fields()[4], value);
      this.timestamp = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'timestamp' field has been set.
      * record log timestamp
      * @return True if the 'timestamp' field has been set, false otherwise.
      */
    public boolean hasTimestamp() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'timestamp' field.
      * record log timestamp
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearTimestamp() {
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'gtid' field.
      * @return The value.
      */
    public java.lang.String getGtid() {
      return gtid;
    }

    /**
      * Sets the value of the 'gtid' field.
      * @param value The value of 'gtid'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setGtid(java.lang.String value) {
      validate(fields()[5], value);
      this.gtid = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'gtid' field has been set.
      * @return True if the 'gtid' field has been set, false otherwise.
      */
    public boolean hasGtid() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'gtid' field.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearGtid() {
      gtid = null;
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'position' field.
      * end_log_pos of last event (exclude commit) in transaction
      * @return The value.
      */
    public java.lang.String getPosition() {
      return position;
    }

    /**
      * Sets the value of the 'position' field.
      * end_log_pos of last event (exclude commit) in transaction
      * @param value The value of 'position'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setPosition(java.lang.String value) {
      validate(fields()[6], value);
      this.position = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'position' field has been set.
      * end_log_pos of last event (exclude commit) in transaction
      * @return True if the 'position' field has been set, false otherwise.
      */
    public boolean hasPosition() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'position' field.
      * end_log_pos of last event (exclude commit) in transaction
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearPosition() {
      position = null;
      fieldSetFlags()[6] = false;
      return this;
    }

    /**
      * Gets the value of the 'safePosition' field.
      * end_log_pos of begin event in transaction
      * @return The value.
      */
    public java.lang.String getSafePosition() {
      return safePosition;
    }

    /**
      * Sets the value of the 'safePosition' field.
      * end_log_pos of begin event in transaction
      * @param value The value of 'safePosition'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setSafePosition(java.lang.String value) {
      validate(fields()[7], value);
      this.safePosition = value;
      fieldSetFlags()[7] = true;
      return this;
    }

    /**
      * Checks whether the 'safePosition' field has been set.
      * end_log_pos of begin event in transaction
      * @return True if the 'safePosition' field has been set, false otherwise.
      */
    public boolean hasSafePosition() {
      return fieldSetFlags()[7];
    }


    /**
      * Clears the value of the 'safePosition' field.
      * end_log_pos of begin event in transaction
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearSafePosition() {
      safePosition = null;
      fieldSetFlags()[7] = false;
      return this;
    }

    /**
      * Gets the value of the 'transactionId' field.
      * transaction id
      * @return The value.
      */
    public java.lang.String getTransactionId() {
      return transactionId;
    }

    /**
      * Sets the value of the 'transactionId' field.
      * transaction id
      * @param value The value of 'transactionId'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setTransactionId(java.lang.String value) {
      validate(fields()[8], value);
      this.transactionId = value;
      fieldSetFlags()[8] = true;
      return this;
    }

    /**
      * Checks whether the 'transactionId' field has been set.
      * transaction id
      * @return True if the 'transactionId' field has been set, false otherwise.
      */
    public boolean hasTransactionId() {
      return fieldSetFlags()[8];
    }


    /**
      * Clears the value of the 'transactionId' field.
      * transaction id
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearTransactionId() {
      transactionId = null;
      fieldSetFlags()[8] = false;
      return this;
    }

    /**
      * Gets the value of the 'serverId' field.
      * @return The value.
      */
    public java.lang.String getServerId() {
      return serverId;
    }

    /**
      * Sets the value of the 'serverId' field.
      * @param value The value of 'serverId'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setServerId(java.lang.String value) {
      validate(fields()[9], value);
      this.serverId = value;
      fieldSetFlags()[9] = true;
      return this;
    }

    /**
      * Checks whether the 'serverId' field has been set.
      * @return True if the 'serverId' field has been set, false otherwise.
      */
    public boolean hasServerId() {
      return fieldSetFlags()[9];
    }


    /**
      * Clears the value of the 'serverId' field.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearServerId() {
      serverId = null;
      fieldSetFlags()[9] = false;
      return this;
    }

    /**
      * Gets the value of the 'threadId' field.
      * @return The value.
      */
    public java.lang.String getThreadId() {
      return threadId;
    }

    /**
      * Sets the value of the 'threadId' field.
      * @param value The value of 'threadId'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setThreadId(java.lang.String value) {
      validate(fields()[10], value);
      this.threadId = value;
      fieldSetFlags()[10] = true;
      return this;
    }

    /**
      * Checks whether the 'threadId' field has been set.
      * @return True if the 'threadId' field has been set, false otherwise.
      */
    public boolean hasThreadId() {
      return fieldSetFlags()[10];
    }


    /**
      * Clears the value of the 'threadId' field.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearThreadId() {
      threadId = null;
      fieldSetFlags()[10] = false;
      return this;
    }

    /**
      * Gets the value of the 'sourceType' field.
      * source database type
      * @return The value.
      */
    public java.lang.String getSourceType() {
      return sourceType;
    }

    /**
      * Sets the value of the 'sourceType' field.
      * source database type
      * @param value The value of 'sourceType'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setSourceType(java.lang.String value) {
      validate(fields()[11], value);
      this.sourceType = value;
      fieldSetFlags()[11] = true;
      return this;
    }

    /**
      * Checks whether the 'sourceType' field has been set.
      * source database type
      * @return True if the 'sourceType' field has been set, false otherwise.
      */
    public boolean hasSourceType() {
      return fieldSetFlags()[11];
    }


    /**
      * Clears the value of the 'sourceType' field.
      * source database type
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearSourceType() {
      sourceType = null;
      fieldSetFlags()[11] = false;
      return this;
    }

    /**
      * Gets the value of the 'sourceVersion' field.
      * source database version
      * @return The value.
      */
    public java.lang.String getSourceVersion() {
      return sourceVersion;
    }

    /**
      * Sets the value of the 'sourceVersion' field.
      * source database version
      * @param value The value of 'sourceVersion'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setSourceVersion(java.lang.String value) {
      validate(fields()[12], value);
      this.sourceVersion = value;
      fieldSetFlags()[12] = true;
      return this;
    }

    /**
      * Checks whether the 'sourceVersion' field has been set.
      * source database version
      * @return True if the 'sourceVersion' field has been set, false otherwise.
      */
    public boolean hasSourceVersion() {
      return fieldSetFlags()[12];
    }


    /**
      * Clears the value of the 'sourceVersion' field.
      * source database version
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearSourceVersion() {
      sourceVersion = null;
      fieldSetFlags()[12] = false;
      return this;
    }

    /**
      * Gets the value of the 'schemaName' field.
      * name of source schema if exist
      * @return The value.
      */
    public java.lang.String getSchemaName() {
      return schemaName;
    }

    /**
      * Sets the value of the 'schemaName' field.
      * name of source schema if exist
      * @param value The value of 'schemaName'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setSchemaName(java.lang.String value) {
      validate(fields()[13], value);
      this.schemaName = value;
      fieldSetFlags()[13] = true;
      return this;
    }

    /**
      * Checks whether the 'schemaName' field has been set.
      * name of source schema if exist
      * @return True if the 'schemaName' field has been set, false otherwise.
      */
    public boolean hasSchemaName() {
      return fieldSetFlags()[13];
    }


    /**
      * Clears the value of the 'schemaName' field.
      * name of source schema if exist
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearSchemaName() {
      schemaName = null;
      fieldSetFlags()[13] = false;
      return this;
    }

    /**
      * Gets the value of the 'tableName' field.
      * name of source table if exist
      * @return The value.
      */
    public java.lang.String getTableName() {
      return tableName;
    }

    /**
      * Sets the value of the 'tableName' field.
      * name of source table if exist
      * @param value The value of 'tableName'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setTableName(java.lang.String value) {
      validate(fields()[14], value);
      this.tableName = value;
      fieldSetFlags()[14] = true;
      return this;
    }

    /**
      * Checks whether the 'tableName' field has been set.
      * name of source table if exist
      * @return True if the 'tableName' field has been set, false otherwise.
      */
    public boolean hasTableName() {
      return fieldSetFlags()[14];
    }


    /**
      * Clears the value of the 'tableName' field.
      * name of source table if exist
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearTableName() {
      tableName = null;
      fieldSetFlags()[14] = false;
      return this;
    }

    /**
      * Gets the value of the 'objectName' field.
      * schemaName.tableName
      * @return The value.
      */
    public java.lang.String getObjectName() {
      return objectName;
    }

    /**
      * Sets the value of the 'objectName' field.
      * schemaName.tableName
      * @param value The value of 'objectName'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setObjectName(java.lang.String value) {
      validate(fields()[15], value);
      this.objectName = value;
      fieldSetFlags()[15] = true;
      return this;
    }

    /**
      * Checks whether the 'objectName' field has been set.
      * schemaName.tableName
      * @return True if the 'objectName' field has been set, false otherwise.
      */
    public boolean hasObjectName() {
      return fieldSetFlags()[15];
    }


    /**
      * Clears the value of the 'objectName' field.
      * schemaName.tableName
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearObjectName() {
      objectName = null;
      fieldSetFlags()[15] = false;
      return this;
    }

    /**
      * Gets the value of the 'columns' field.
      * @return The value.
      */
    public java.util.List<com.tencent.subscribe.avro.Field> getColumns() {
      return columns;
    }

    /**
      * Sets the value of the 'columns' field.
      * @param value The value of 'columns'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setColumns(java.util.List<com.tencent.subscribe.avro.Field> value) {
      validate(fields()[16], value);
      this.columns = value;
      fieldSetFlags()[16] = true;
      return this;
    }

    /**
      * Checks whether the 'columns' field has been set.
      * @return True if the 'columns' field has been set, false otherwise.
      */
    public boolean hasColumns() {
      return fieldSetFlags()[16];
    }


    /**
      * Clears the value of the 'columns' field.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearColumns() {
      columns = null;
      fieldSetFlags()[16] = false;
      return this;
    }

    /**
      * Gets the value of the 'oldColumns' field.
      * values of a row before modify. if values' size is over 20M, they will be discarded
      * @return The value.
      */
    public java.lang.Object getOldColumns() {
      return oldColumns;
    }

    /**
      * Sets the value of the 'oldColumns' field.
      * values of a row before modify. if values' size is over 20M, they will be discarded
      * @param value The value of 'oldColumns'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setOldColumns(java.lang.Object value) {
      validate(fields()[17], value);
      this.oldColumns = value;
      fieldSetFlags()[17] = true;
      return this;
    }

    /**
      * Checks whether the 'oldColumns' field has been set.
      * values of a row before modify. if values' size is over 20M, they will be discarded
      * @return True if the 'oldColumns' field has been set, false otherwise.
      */
    public boolean hasOldColumns() {
      return fieldSetFlags()[17];
    }


    /**
      * Clears the value of the 'oldColumns' field.
      * values of a row before modify. if values' size is over 20M, they will be discarded
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearOldColumns() {
      oldColumns = null;
      fieldSetFlags()[17] = false;
      return this;
    }

    /**
      * Gets the value of the 'newColumns' field.
      * values of a row after modify. if values' size is over 20M, they will be discarded
      * @return The value.
      */
    public java.lang.Object getNewColumns() {
      return newColumns;
    }

    /**
      * Sets the value of the 'newColumns' field.
      * values of a row after modify. if values' size is over 20M, they will be discarded
      * @param value The value of 'newColumns'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setNewColumns(java.lang.Object value) {
      validate(fields()[18], value);
      this.newColumns = value;
      fieldSetFlags()[18] = true;
      return this;
    }

    /**
      * Checks whether the 'newColumns' field has been set.
      * values of a row after modify. if values' size is over 20M, they will be discarded
      * @return True if the 'newColumns' field has been set, false otherwise.
      */
    public boolean hasNewColumns() {
      return fieldSetFlags()[18];
    }


    /**
      * Clears the value of the 'newColumns' field.
      * values of a row after modify. if values' size is over 20M, they will be discarded
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearNewColumns() {
      newColumns = null;
      fieldSetFlags()[18] = false;
      return this;
    }

    /**
      * Gets the value of the 'sql' field.
      * ddl sql if this is a ddl event
      * @return The value.
      */
    public java.lang.String getSql() {
      return sql;
    }

    /**
      * Sets the value of the 'sql' field.
      * ddl sql if this is a ddl event
      * @param value The value of 'sql'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setSql(java.lang.String value) {
      validate(fields()[19], value);
      this.sql = value;
      fieldSetFlags()[19] = true;
      return this;
    }

    /**
      * Checks whether the 'sql' field has been set.
      * ddl sql if this is a ddl event
      * @return True if the 'sql' field has been set, false otherwise.
      */
    public boolean hasSql() {
      return fieldSetFlags()[19];
    }


    /**
      * Clears the value of the 'sql' field.
      * ddl sql if this is a ddl event
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearSql() {
      sql = null;
      fieldSetFlags()[19] = false;
      return this;
    }

    /**
      * Gets the value of the 'executionTime' field.
      * execution time of ddl sql
      * @return The value.
      */
    public java.lang.Integer getExecutionTime() {
      return executionTime;
    }

    /**
      * Sets the value of the 'executionTime' field.
      * execution time of ddl sql
      * @param value The value of 'executionTime'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setExecutionTime(int value) {
      validate(fields()[20], value);
      this.executionTime = value;
      fieldSetFlags()[20] = true;
      return this;
    }

    /**
      * Checks whether the 'executionTime' field has been set.
      * execution time of ddl sql
      * @return True if the 'executionTime' field has been set, false otherwise.
      */
    public boolean hasExecutionTime() {
      return fieldSetFlags()[20];
    }


    /**
      * Clears the value of the 'executionTime' field.
      * execution time of ddl sql
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearExecutionTime() {
      fieldSetFlags()[20] = false;
      return this;
    }

    /**
      * Gets the value of the 'heartbeatTimestamp' field.
      * timestamp of heartbeat send by master if this is a heartbeat record
      * @return The value.
      */
    public java.lang.Long getHeartbeatTimestamp() {
      return heartbeatTimestamp;
    }

    /**
      * Sets the value of the 'heartbeatTimestamp' field.
      * timestamp of heartbeat send by master if this is a heartbeat record
      * @param value The value of 'heartbeatTimestamp'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setHeartbeatTimestamp(long value) {
      validate(fields()[21], value);
      this.heartbeatTimestamp = value;
      fieldSetFlags()[21] = true;
      return this;
    }

    /**
      * Checks whether the 'heartbeatTimestamp' field has been set.
      * timestamp of heartbeat send by master if this is a heartbeat record
      * @return True if the 'heartbeatTimestamp' field has been set, false otherwise.
      */
    public boolean hasHeartbeatTimestamp() {
      return fieldSetFlags()[21];
    }


    /**
      * Clears the value of the 'heartbeatTimestamp' field.
      * timestamp of heartbeat send by master if this is a heartbeat record
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearHeartbeatTimestamp() {
      fieldSetFlags()[21] = false;
      return this;
    }

    /**
      * Gets the value of the 'syncedGtid' field.
      * @return The value.
      */
    public java.lang.String getSyncedGtid() {
      return syncedGtid;
    }

    /**
      * Sets the value of the 'syncedGtid' field.
      * @param value The value of 'syncedGtid'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setSyncedGtid(java.lang.String value) {
      validate(fields()[22], value);
      this.syncedGtid = value;
      fieldSetFlags()[22] = true;
      return this;
    }

    /**
      * Checks whether the 'syncedGtid' field has been set.
      * @return True if the 'syncedGtid' field has been set, false otherwise.
      */
    public boolean hasSyncedGtid() {
      return fieldSetFlags()[22];
    }


    /**
      * Clears the value of the 'syncedGtid' field.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearSyncedGtid() {
      syncedGtid = null;
      fieldSetFlags()[22] = false;
      return this;
    }

    /**
      * Gets the value of the 'fakeGtid' field.
      * for some database that has no gtid, a fake gtid will be assigned
      * @return The value.
      */
    public java.lang.Boolean getFakeGtid() {
      return fakeGtid;
    }

    /**
      * Sets the value of the 'fakeGtid' field.
      * for some database that has no gtid, a fake gtid will be assigned
      * @param value The value of 'fakeGtid'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setFakeGtid(boolean value) {
      validate(fields()[23], value);
      this.fakeGtid = value;
      fieldSetFlags()[23] = true;
      return this;
    }

    /**
      * Checks whether the 'fakeGtid' field has been set.
      * for some database that has no gtid, a fake gtid will be assigned
      * @return True if the 'fakeGtid' field has been set, false otherwise.
      */
    public boolean hasFakeGtid() {
      return fieldSetFlags()[23];
    }


    /**
      * Clears the value of the 'fakeGtid' field.
      * for some database that has no gtid, a fake gtid will be assigned
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearFakeGtid() {
      fieldSetFlags()[23] = false;
      return this;
    }

    /**
      * Gets the value of the 'pkNames' field.
      * primary keys
      * @return The value.
      */
    public java.util.List<java.lang.String> getPkNames() {
      return pkNames;
    }

    /**
      * Sets the value of the 'pkNames' field.
      * primary keys
      * @param value The value of 'pkNames'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setPkNames(java.util.List<java.lang.String> value) {
      validate(fields()[24], value);
      this.pkNames = value;
      fieldSetFlags()[24] = true;
      return this;
    }

    /**
      * Checks whether the 'pkNames' field has been set.
      * primary keys
      * @return True if the 'pkNames' field has been set, false otherwise.
      */
    public boolean hasPkNames() {
      return fieldSetFlags()[24];
    }


    /**
      * Clears the value of the 'pkNames' field.
      * primary keys
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearPkNames() {
      pkNames = null;
      fieldSetFlags()[24] = false;
      return this;
    }

    /**
      * Gets the value of the 'readerTimestamp' field.
      * a millisecond timestamp. Not implemented at current version
      * @return The value.
      */
    public java.lang.Long getReaderTimestamp() {
      return readerTimestamp;
    }

    /**
      * Sets the value of the 'readerTimestamp' field.
      * a millisecond timestamp. Not implemented at current version
      * @param value The value of 'readerTimestamp'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setReaderTimestamp(long value) {
      validate(fields()[25], value);
      this.readerTimestamp = value;
      fieldSetFlags()[25] = true;
      return this;
    }

    /**
      * Checks whether the 'readerTimestamp' field has been set.
      * a millisecond timestamp. Not implemented at current version
      * @return True if the 'readerTimestamp' field has been set, false otherwise.
      */
    public boolean hasReaderTimestamp() {
      return fieldSetFlags()[25];
    }


    /**
      * Clears the value of the 'readerTimestamp' field.
      * a millisecond timestamp. Not implemented at current version
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearReaderTimestamp() {
      fieldSetFlags()[25] = false;
      return this;
    }

    /**
      * Gets the value of the 'tags' field.
      * tags to identify properties of this record
      * @return The value.
      */
    public java.util.Map<java.lang.String,java.lang.String> getTags() {
      return tags;
    }

    /**
      * Sets the value of the 'tags' field.
      * tags to identify properties of this record
      * @param value The value of 'tags'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setTags(java.util.Map<java.lang.String,java.lang.String> value) {
      validate(fields()[26], value);
      this.tags = value;
      fieldSetFlags()[26] = true;
      return this;
    }

    /**
      * Checks whether the 'tags' field has been set.
      * tags to identify properties of this record
      * @return True if the 'tags' field has been set, false otherwise.
      */
    public boolean hasTags() {
      return fieldSetFlags()[26];
    }


    /**
      * Clears the value of the 'tags' field.
      * tags to identify properties of this record
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearTags() {
      tags = null;
      fieldSetFlags()[26] = false;
      return this;
    }

    /**
      * Gets the value of the 'index' field.
      * Not implemented at current version
      * @return The value.
      */
    public java.lang.Integer getIndex() {
      return index;
    }

    /**
      * Sets the value of the 'index' field.
      * Not implemented at current version
      * @param value The value of 'index'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setIndex(int value) {
      validate(fields()[27], value);
      this.index = value;
      fieldSetFlags()[27] = true;
      return this;
    }

    /**
      * Checks whether the 'index' field has been set.
      * Not implemented at current version
      * @return True if the 'index' field has been set, false otherwise.
      */
    public boolean hasIndex() {
      return fieldSetFlags()[27];
    }


    /**
      * Clears the value of the 'index' field.
      * Not implemented at current version
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearIndex() {
      fieldSetFlags()[27] = false;
      return this;
    }

    /**
      * Gets the value of the 'total' field.
      * Not implemented at current version
      * @return The value.
      */
    public java.lang.Integer getTotal() {
      return total;
    }

    /**
      * Sets the value of the 'total' field.
      * Not implemented at current version
      * @param value The value of 'total'.
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder setTotal(int value) {
      validate(fields()[28], value);
      this.total = value;
      fieldSetFlags()[28] = true;
      return this;
    }

    /**
      * Checks whether the 'total' field has been set.
      * Not implemented at current version
      * @return True if the 'total' field has been set, false otherwise.
      */
    public boolean hasTotal() {
      return fieldSetFlags()[28];
    }


    /**
      * Clears the value of the 'total' field.
      * Not implemented at current version
      * @return This builder.
      */
    public com.tencent.subscribe.avro.Record.Builder clearTotal() {
      fieldSetFlags()[28] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Record build() {
      try {
        Record record = new Record();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.Long) defaultValue(fields()[0]);
        record.version = fieldSetFlags()[1] ? this.version : (java.lang.Integer) defaultValue(fields()[1]);
        record.messageType = fieldSetFlags()[2] ? this.messageType : (com.tencent.subscribe.avro.MessageType) defaultValue(fields()[2]);
        record.fileName = fieldSetFlags()[3] ? this.fileName : (java.lang.String) defaultValue(fields()[3]);
        record.timestamp = fieldSetFlags()[4] ? this.timestamp : (java.lang.Long) defaultValue(fields()[4]);
        record.gtid = fieldSetFlags()[5] ? this.gtid : (java.lang.String) defaultValue(fields()[5]);
        record.position = fieldSetFlags()[6] ? this.position : (java.lang.String) defaultValue(fields()[6]);
        record.safePosition = fieldSetFlags()[7] ? this.safePosition : (java.lang.String) defaultValue(fields()[7]);
        record.transactionId = fieldSetFlags()[8] ? this.transactionId : (java.lang.String) defaultValue(fields()[8]);
        record.serverId = fieldSetFlags()[9] ? this.serverId : (java.lang.String) defaultValue(fields()[9]);
        record.threadId = fieldSetFlags()[10] ? this.threadId : (java.lang.String) defaultValue(fields()[10]);
        record.sourceType = fieldSetFlags()[11] ? this.sourceType : (java.lang.String) defaultValue(fields()[11]);
        record.sourceVersion = fieldSetFlags()[12] ? this.sourceVersion : (java.lang.String) defaultValue(fields()[12]);
        record.schemaName = fieldSetFlags()[13] ? this.schemaName : (java.lang.String) defaultValue(fields()[13]);
        record.tableName = fieldSetFlags()[14] ? this.tableName : (java.lang.String) defaultValue(fields()[14]);
        record.objectName = fieldSetFlags()[15] ? this.objectName : (java.lang.String) defaultValue(fields()[15]);
        record.columns = fieldSetFlags()[16] ? this.columns : (java.util.List<com.tencent.subscribe.avro.Field>) defaultValue(fields()[16]);
        record.oldColumns = fieldSetFlags()[17] ? this.oldColumns : (java.lang.Object) defaultValue(fields()[17]);
        record.newColumns = fieldSetFlags()[18] ? this.newColumns : (java.lang.Object) defaultValue(fields()[18]);
        record.sql = fieldSetFlags()[19] ? this.sql : (java.lang.String) defaultValue(fields()[19]);
        record.executionTime = fieldSetFlags()[20] ? this.executionTime : (java.lang.Integer) defaultValue(fields()[20]);
        record.heartbeatTimestamp = fieldSetFlags()[21] ? this.heartbeatTimestamp : (java.lang.Long) defaultValue(fields()[21]);
        record.syncedGtid = fieldSetFlags()[22] ? this.syncedGtid : (java.lang.String) defaultValue(fields()[22]);
        record.fakeGtid = fieldSetFlags()[23] ? this.fakeGtid : (java.lang.Boolean) defaultValue(fields()[23]);
        record.pkNames = fieldSetFlags()[24] ? this.pkNames : (java.util.List<java.lang.String>) defaultValue(fields()[24]);
        record.readerTimestamp = fieldSetFlags()[25] ? this.readerTimestamp : (java.lang.Long) defaultValue(fields()[25]);
        record.tags = fieldSetFlags()[26] ? this.tags : (java.util.Map<java.lang.String,java.lang.String>) defaultValue(fields()[26]);
        record.index = fieldSetFlags()[27] ? this.index : (java.lang.Integer) defaultValue(fields()[27]);
        record.total = fieldSetFlags()[28] ? this.total : (java.lang.Integer) defaultValue(fields()[28]);
        return record;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Record>
    WRITER$ = (org.apache.avro.io.DatumWriter<Record>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Record>
    READER$ = (org.apache.avro.io.DatumReader<Record>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}
